Asterisk.org: Developer Documentation (28 Oct 2009)

Wed Oct 28 15:49:12 2009

## Asterisk developer's documentation

# plc.h File Reference

SpanDSP - a series of DSP components for telephony. More...

`#include <stdint.h>`

Include dependency graph for plc.h:

This graph shows which files directly or indirectly include this file:

Go to the source code of this file.

## Data Structures

struct | plc_state_t

## Defines

#define | _PLC_H_
#define | CORRELATION_SPAN 160
#define | PLC_HISTORY_LEN (CORRELATION_SPAN + PLC_PITCH_MIN)
#define | PLC_PITCH_MAX 40
#define | PLC_PITCH_MIN 120
#define | PLC_PITCH_OVERLAP_MAX (PLC_PITCH_MIN >> 2)
#define | SAMPLE_RATE 8000

## Functions

int | plc_fillin (plc_state_t *s, int16_t amp[], int len)
| Fill-in a block of missing audio samples.
plc_state_t * | plc_init (plc_state_t *s)
| Process a block of received V.29 modem audio samples.
int | plc_rx (plc_state_t *s, int16_t amp[], int len)
| Process a block of received audio samples.

## Detailed Description

SpanDSP - a series of DSP components for telephony.

plc.h

Author:
  Steve Underwood <steveu@coppice.org>

Copyright (C) 2004 Steve Underwood

All rights reserved.

This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program; if not, write to the Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

This version may be optionally licenced under the GNU LGPL licence.

A license has been granted to Digium (via disclaimer) for the use of this code.

Definition in file plc.h.

## Define Documentation

#define _PLC_H_

Definition at line 34 of file plc.h.

#define CORRELATION_SPAN 160

The length over which the AMDF function looks for similarity (20 ms)

Definition at line 109 of file plc.h.

Referenced by plc_fillin().

#define PLC_HISTORY_LEN (CORRELATION_SPAN + PLC_PITCH_MIN)

History buffer length. The buffer much also be at leat 1.25 times PLC_PITCH_MIN, but that is much smaller than the buffer needs to be for the pitch assessment.

Definition at line 113 of file plc.h.

Referenced by normalise_history(), plc_fillin(), and save_history().

#define PLC_PITCH_MAX 40

Maximum allowed pitch (200 Hz)

Definition at line 105 of file plc.h.

Referenced by plc_fillin().

#define PLC_PITCH_MIN 120

Minimum allowed pitch (66 Hz)

Definition at line 103 of file plc.h.

Referenced by plc_fillin().

#define PLC_PITCH_OVERLAP_MAX (PLC_PITCH_MIN >> 2)

Maximum pitch OLA window

Definition at line 107 of file plc.h.

#define SAMPLE_RATE 8000

Definition at line 100 of file plc.h.

## Function Documentation

int plc_fillin | ( | plc_state_t * | s,
|  | int16_t | amp[],
|  | int | len |
| ) |  |  |

Fill-in a block of missing audio samples.

Fill-in a block of missing audio samples.

Parameters:

  | s | The packet loss concealer context.
  | amp | The audio sample buffer.
  | len | The number of samples to be synthesised.

Returns:
  The number of samples synthesized.

Definition at line 174 of file plc.c.

References amdf_pitch(), ATTENUATION_INCREMENT, CORRELATION_SPAN, fsaturate(), plc_state_t::history, plc_state_t::missing_samples, normalise_history(), plc_state_t::pitch, plc_state_t::pitch_offset, plc_state_t::pitchbuf, PLC_HISTORY_LEN, PLC_PITCH_MAX, PLC_PITCH_MIN, and save_history().

Referenced by adpcmtolin_framein(), alawtolin_framein(), g726tolin_framein(), gsmtolin_framein(), lpc10tolin_framein(), and ulawtolin_framein().

    00175 {
    00176    int i;
    00177    int pitch_overlap;
    00178    float old_step;
    00179    float new_step;
    00180    float old_weight;
    00181    float new_weight;
    00182    float gain;
    00183    int16_t *orig_amp;
    00184    int orig_len;
    00185
    00186    orig_amp = amp;
    00187    orig_len = len;
    00188    if (s->missing_samples == 0) {
    00189       /* As the gap in real speech starts we need to assess the last known pitch,
    00190          and prepare the synthetic data we will use for fill-in */
    00191       normalise_history(s);
    00192       s->pitch = amdf_pitch(PLC_PITCH_MIN, PLC_PITCH_MAX, s->history + PLC_HISTORY_LEN - CORRELATION_SPAN - PLC_PITCH_MIN, CORRELATION_SPAN);
    00193       /* We overlap a 1/4 wavelength */
    00194       pitch_overlap = s->pitch >> 2;
    00195       /* Cook up a single cycle of pitch, using a single of the real signal with 1/4
    00196          cycle OLA'ed to make the ends join up nicely */
    00197       /* The first 3/4 of the cycle is a simple copy */
    00198       for (i = 0;  i < s->pitch - pitch_overlap;  i++)
    00199          s->pitchbuf[i] = s->history[PLC_HISTORY_LEN - s->pitch + i];
    00200       /* The last 1/4 of the cycle is overlapped with the end of the previous cycle */
    00201       new_step = 1.0/pitch_overlap;
    00202       new_weight = new_step;
    00203       for (  ;  i < s->pitch;  i++) {
    00204          s->pitchbuf[i] = s->history[PLC_HISTORY_LEN - s->pitch + i]*(1.0 - new_weight) + s->history[PLC_HISTORY_LEN - 2*s->pitch + i]*new_weight;
    00205          new_weight += new_step;
    00206       }
    00207       /* We should now be ready to fill in the gap with repeated, decaying cycles
    00208          of what is in pitchbuf */
    00209
    00210       /* We need to OLA the first 1/4 wavelength of the synthetic data, to smooth
    00211          it into the previous real data. To avoid the need to introduce a delay
    00212          in the stream, reverse the last 1/4 wavelength, and OLA with that. */
    00213       gain = 1.0;
    00214       new_step = 1.0/pitch_overlap;
    00215       old_step = new_step;
    00216       new_weight = new_step;
    00217       old_weight = 1.0 - new_step;
    00218       for (i = 0;  i < pitch_overlap;  i++) {
    00219          amp[i] = fsaturate(old_weight*s->history[PLC_HISTORY_LEN - 1 - i] + new_weight*s->pitchbuf[i]);
    00220          new_weight += new_step;
    00221          old_weight -= old_step;
    00222          if (old_weight < 0.0)
    00223             old_weight = 0.0;
    00224       }
    00225       s->pitch_offset = i;
    00226    } else {
    00227       gain = 1.0 - s->missing_samples*ATTENUATION_INCREMENT;
    00228       i = 0;
    00229    }
    00230    for (  ;  gain > 0.0  &&  i < len;  i++) {
    00231       amp[i] = s->pitchbuf[s->pitch_offset]*gain;
    00232       gain -= ATTENUATION_INCREMENT;
    00233       if (++s->pitch_offset >= s->pitch)
    00234          s->pitch_offset = 0;
    00235    }
    00236    for (  ;  i < len;  i++)
    00237       amp[i] = 0;
    00238    s->missing_samples += orig_len;
    00239    save_history(s, amp, len);
    00240    return len;
    00241 }

plc_state_t* plc_init | ( | plc_state_t * | s | ) |

Process a block of received V.29 modem audio samples.

Process a block of received V.29 modem audio samples.

Parameters:

  | s | The packet loss concealer context.

Returns:
  A pointer to the he packet loss concealer context.

Definition at line 245 of file plc.c.

Referenced by adpcmtolin_new(), alawtolin_new(), g726tolin_new(), gsm_new(), lpc10_dec_new(), and ulawtolin_new().

    00246 {
    00247    memset(s, 0, sizeof(*s));
    00248    return s;
    00249 }

int plc_rx | ( | plc_state_t * | s,
|  | int16_t | amp[],
|  | int | len |
| ) |  |  |

Process a block of received audio samples.

Process a block of received audio samples.

Parameters:

  | s | The packet loss concealer context.
  | amp | The audio sample buffer.
  | len | The number of samples in the buffer.

Returns:
  The number of samples in the buffer.

Definition at line 131 of file plc.c.

References ATTENUATION_INCREMENT, fsaturate(), plc_state_t::missing_samples, plc_state_t::pitch, plc_state_t::pitch_offset, plc_state_t::pitchbuf, and save_history().

Referenced by adpcmtolin_framein(), alawtolin_framein(), g726tolin_framein(), gsmtolin_framein(), lpc10tolin_framein(), and ulawtolin_framein().

    00132 {
    00133    int i;
    00134    int pitch_overlap;
    00135    float old_step;
    00136    float new_step;
    00137    float old_weight;
    00138    float new_weight;
    00139    float gain;
    00140
    00141    if (s->missing_samples) {
    00142       /* Although we have a real signal, we need to smooth it to fit well
    00143       with the synthetic signal we used for the previous block */
    00144
    00145       /* The start of the real data is overlapped with the next 1/4 cycle
    00146          of the synthetic data. */
    00147       pitch_overlap = s->pitch >> 2;
    00148       if (pitch_overlap > len)
    00149          pitch_overlap = len;
    00150       gain = 1.0 - s->missing_samples*ATTENUATION_INCREMENT;
    00151       if (gain < 0.0)
    00152          gain = 0.0;
    00153       new_step = 1.0/pitch_overlap;
    00154       old_step = new_step*gain;
    00155       new_weight = new_step;
    00156       old_weight = (1.0 - new_step)*gain;
    00157       for (i = 0;  i < pitch_overlap;  i++) {
    00158          amp[i] = fsaturate(old_weight*s->pitchbuf[s->pitch_offset] + new_weight*amp[i]);
    00159          if (++s->pitch_offset >= s->pitch)
    00160             s->pitch_offset = 0;
    00161          new_weight += new_step;
    00162          old_weight -= old_step;
    00163          if (old_weight < 0.0)
    00164             old_weight = 0.0;
    00165       }
    00166       s->missing_samples = 0;
    00167    }
    00168    save_history(s, amp, len);
    00169    return len;
    00170 }